﻿
'_Template settings_________________________________________________________
' MyGen. Ver.: 1.3.0.9                                 
' Template   : Miranda x Vb.Net, ver. 1.8.8                                   
' Author     : Gianluca Pezzoli. @CopyRight 2010 Dott. Ing. Gianluca Pezzoli  
' DB Name    : TESTNET
' Table Name : TBLCONCHIAVEIDENTITY
' Namespace  : <none>
' Entity     : TBLCONCHIAVEIDENTITY
' FormBinding: Vero
' UndoChanges: Vero
' Language   : VB.NET
' DbTarget   : OracleClient 
' User MetaDB: \\pezzolidell\e$\DatiNuovi\Sviluppo\Linguaggi\VB.NET\2010\DB\ORM\Miranda\UserMetaData.xml
' Created  on: 05/07/2010 21:46:40
'___________________________________________________________________________

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda


<Serializable()> _
<TableMapping("TBLCONCHIAVEIDENTITY", "TBLCONCHIAVEIDENTITY", "IDVALUTA", "SEQUENCE1")> _
Partial Public Class TBLCONCHIAVEIDENTITY
    Implements IEntity, INotifyPropertyChanged, INotifyPropertyChanging, IEditableObject

#Region "   Enum with Entity Properties binded to DB Table columns"
    Public Enum LinkedProperties
        IDVALUTA
        VALUTA
        CAMBIO
        NOME
    End Enum
#End Region

#Region "   Private members generated from columns of the table"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _IDVALUTA As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _VALUTA As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _CAMBIO As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _NOME As String
#End Region

    Private Sub SetDefaultValuesForBindedProperties()
    End Sub

    Public Sub New()
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

    Protected Sub InitPrivateProperties()
        _IDVALUTA = 0
        _VALUTA = Nothing
        _CAMBIO = 0
        _NOME = Nothing

        ' Per i campi con un Default nel DB metto il Default
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos	
    End Sub

    Public Sub Clear()
        InitPrivateProperties()

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

#Region "   Public properties generated from columns of the table"

    <ColumnMappingAttribute("IDVALUTA", "NUMBER", True, True, False, 0, 3, 0)> _
  <Bindable(True)> _
    Public ReadOnly Property IDVALUTA As Decimal
        Get
            Return _IDVALUTA
        End Get
    End Property

    <ColumnMappingAttribute("VALUTA", "VARCHAR2", False, False, False, 3, 0, 0)> _
  <Bindable(True)> _
    Public Property VALUTA As String
        Get
            Return _VALUTA
        End Get
        Set(ByVal Value As String)
            If (_VALUTA Is Nothing And Value IsNot Nothing) _
                OrElse (_VALUTA IsNot Nothing AndAlso Not _VALUTA.Equals(Value)) Then
                OnPropertyChanging("VALUTA")
                _VALUTA = Value
                OnPropertyChanged("VALUTA")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("CAMBIO", "FLOAT", False, False, False, 0, 15, 0)> _
  <Bindable(True)> _
    Public Property CAMBIO As Decimal
        Get
            Return _CAMBIO
        End Get
        Set(ByVal Value As Decimal)
            If Not Value.Equals(_CAMBIO) Then
                OnPropertyChanging("CAMBIO")
                _CAMBIO = Value
                OnPropertyChanged("CAMBIO")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("NOME", "VARCHAR2", False, False, True, 12, 0, 0)> _
  <Bindable(True)> _
    Public Property NOME As String
        Get
            Return _NOME
        End Get
        Set(ByVal Value As String)
            If (_NOME Is Nothing And Value IsNot Nothing) _
                OrElse (_NOME IsNot Nothing AndAlso Not _NOME.Equals(Value)) Then
                OnPropertyChanging("NOME")
                _NOME = Value
                OnPropertyChanged("NOME")
            End If
        End Set
    End Property
#End Region

#Region "   IEntity implementation"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
    Protected _Status As EntityStatus
    Public Event EntityChanged(ByVal sender As Object, ByVal e As EntityActionEventArgs) Implements Pezzoli.Data.Miranda.IEntity.EntityChanged

    Public Sub SetStatus(ByVal newStatus As Pezzoli.Data.Miranda.EntityStatus) Implements Pezzoli.Data.Miranda.IEntity.SetStatus
        If newStatus = _Status Then Exit Sub

        _PreviousStatus = _Status
        _Status = newStatus
        'RaiseEvent EntityChanged(Me, New EntityActionEventArgs())
        Select Case _Status
            Case EntityStatus.Editing
                If _PreviousStatus = EntityStatus.Empty Then
                    RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyNew))
                Else
                    RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
                End If

            Case EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Create))

            Case EntityStatus.Loaded
                UpdateBackupProperties() ' I valori vecchi diventano uguali a quelli attuali				
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Load))

            Case EntityStatus.Deleted
                UpdateBackupProperties() ' I valori vecchi diventano uguali a quelli attuali
                InitPrivateProperties() ' Pulisco i valori ufficiali
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Delete))
        End Select
    End Sub

    <Bindable(False)> _
    <Browsable(False)> _
    Public ReadOnly Property Status As Pezzoli.Data.Miranda.EntityStatus Implements Pezzoli.Data.Miranda.IEntity.Status
        Get
            Return _Status
        End Get
    End Property
#End Region

#Region "   INotifyPropertyChanged implementation"
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Protected Sub OnPropertyChanged(ByVal field As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
        SetStatus(EntityStatus.Editing)
    End Sub
#End Region

#Region "   INotifyPropertyChanging implementation"
    Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

    Protected Sub OnPropertyChanging(ByVal field As String)
        RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
    End Sub
#End Region
#Region "   IEditableObject implementation"
    'Private _Editing as Boolean
    'Private _New As Boolean
    'Private _Parent As ....
    Protected _PreviousStatus As EntityStatus

#Region "   Members for saving original values of table linked columns"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_IDVALUTA As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_VALUTA As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_CAMBIO As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_NOME As String
#End Region

    '   Friend Sub SetParent(ByVal parent As ...)
    '      _Parent = parent
    '   End Sub

    Protected Sub UpdateBackupProperties()
        _Orig_IDVALUTA = _IDVALUTA
        _Orig_VALUTA = _VALUTA
        _Orig_CAMBIO = _CAMBIO
        _Orig_NOME = _NOME
    End Sub

    Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
        'If Not _Editing Then 
        If _Status = EntityStatus.Empty Or _Status = EntityStatus.Loaded Then
            UpdateBackupProperties()
            '_Editing = True
            _PreviousStatus = _Status
            _Status = EntityStatus.Editing

            If _PreviousStatus = EntityStatus.Empty Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyNew))
            End If
            If _PreviousStatus = EntityStatus.Loaded Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
            End If
        End If
    End Sub

    Public Sub CancelEdit(ByVal propertyName As LinkedProperties)
        If HasChanges(propertyName) Then
            Select Case propertyName
                Case LinkedProperties.IDVALUTA
                    _IDVALUTA = _Orig_IDVALUTA
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDVALUTA"))
                Case LinkedProperties.VALUTA
                    _VALUTA = _Orig_VALUTA
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("VALUTA"))
                Case LinkedProperties.CAMBIO
                    _CAMBIO = _Orig_CAMBIO
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("CAMBIO"))
                Case LinkedProperties.NOME
                    _NOME = _Orig_NOME
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("NOME"))
            End Select

            If Not HasChanges() Then _Status = _PreviousStatus
        End If
        '_Editing = False
    End Sub

    Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
        'If _New Then
        If _Status = EntityStatus.Empty Then
            '_Parent.Remove(Me)
        Else
            CancelEdit(LinkedProperties.IDVALUTA)
            CancelEdit(LinkedProperties.VALUTA)
            CancelEdit(LinkedProperties.CAMBIO)
            CancelEdit(LinkedProperties.NOME)

            If _PreviousStatus = EntityStatus.Empty Then
                _Status = EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditNew))
            Else
                _Status = EntityStatus.Loaded
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditLoaded))
            End If
        End If
        '_Editing = False
    End Sub

    Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
        '_Editing = False
        '_New = False
        _PreviousStatus = _Status
        _Status = EntityStatus.Loaded
        'RaiseEvent EntityChanged(Me, System.EventArgs.Empty)
        If _PreviousStatus = EntityStatus.Loaded Then
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditLoaded))
        Else
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditNew))
        End If
    End Sub

    Public Function GetOriginalValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case LinkedProperties.IDVALUTA
                Return _Orig_IDVALUTA
            Case LinkedProperties.VALUTA
                Return _Orig_VALUTA
            Case LinkedProperties.CAMBIO
                Return _Orig_CAMBIO
            Case LinkedProperties.NOME
                Return _Orig_NOME
            Case Else
                Return Nothing
        End Select
    End Function

    Public Function HasChanges(ByVal propertyName As LinkedProperties) As Boolean
        Select Case propertyName
            Case LinkedProperties.IDVALUTA
                If Not _IDVALUTA.Equals(_Orig_IDVALUTA) Then Return True
            Case LinkedProperties.VALUTA
                If (_VALUTA Is Nothing And _Orig_VALUTA IsNot Nothing) _
                    OrElse (_VALUTA IsNot Nothing AndAlso Not _VALUTA.Equals(_Orig_VALUTA)) Then
                    Return True
                End If
            Case LinkedProperties.CAMBIO
                If Not _CAMBIO.Equals(_Orig_CAMBIO) Then Return True
            Case LinkedProperties.NOME
                If (_NOME Is Nothing And _Orig_NOME IsNot Nothing) _
                    OrElse (_NOME IsNot Nothing AndAlso Not _NOME.Equals(_Orig_NOME)) Then
                    Return True
                End If
        End Select
        Return False
    End Function

    Public Function HasChanges() As Boolean
        'If _Status = Pezzoli.Data.Miranda.EntityStatus.Editing Then
        If HasChanges(LinkedProperties.IDVALUTA) _
            Or HasChanges(LinkedProperties.VALUTA) _
            Or HasChanges(LinkedProperties.CAMBIO) _
            Or HasChanges(LinkedProperties.NOME) _
        Then
            Return True
        Else
            Return False
        End If
    End Function
#End Region


#Region "   Utilities"
    Public Shared Function MaxLength(ByVal propertyName As LinkedProperties) As Integer
        Select Case propertyName
            Case LinkedProperties.VALUTA
                Return 3
            Case LinkedProperties.NOME
                Return 12
            Case Else
                Return Integer.MaxValue
        End Select
    End Function

    Public Shared Function DefaultValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case Else
                Return Nothing
        End Select
    End Function
#End Region
End Class