﻿
'_Template settings_________________________________________________________
' MyGen. Ver.: 1.3.0.9                                 
' Template   : Miranda x Vb.Net, ver. 1.8.8                                   
' Author     : Gianluca Pezzoli. @CopyRight 2010 Dott. Ing. Gianluca Pezzoli  
' DB Name    : TESTNET
' Table Name : TBLCONCHIAVECOMPOSTA
' Namespace  : <none>
' Entity     : TBLCONCHIAVECOMPOSTA
' FormBinding: Vero
' UndoChanges: Vero
' Language   : VB.NET
' DbTarget   : OracleClient 
' User MetaDB: \\pezzolidell\e$\DatiNuovi\Sviluppo\Linguaggi\VB.NET\2010\DB\ORM\Miranda\UserMetaData.xml
' Created  on: 05/07/2010 21:44:54
'___________________________________________________________________________

Imports System
Imports System.ComponentModel
Imports Pezzoli.Data.Miranda


<Serializable()> _
<TableMapping("TBLCONCHIAVECOMPOSTA", "TBLCONCHIAVECOMPOSTA", "IDCONDIZIONE,IDCONTO,IDTIPO,VALIDOAL,VALIDODAL", "")> _
Partial Public Class TBLCONCHIAVECOMPOSTA
    Implements IEntity, INotifyPropertyChanged, INotifyPropertyChanging, IEditableObject

#Region "   Enum with Entity Properties binded to DB Table columns"
    Public Enum LinkedProperties
        IDCONTO
        IDCONDIZIONE
        IDTIPO
        VALORE
        DESCRIZIONE
        VALIDODAL
        VALIDOAL
        VIRGOLADOPPIA
        REALE
    End Enum
#End Region

#Region "   Private members generated from columns of the table"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _IDCONTO As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _IDCONDIZIONE As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _IDTIPO As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _VALORE As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _DESCRIZIONE As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _VALIDODAL As DateTime
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _VALIDOAL As DateTime
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _VIRGOLADOPPIA As Nullable(Of Decimal)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _REALE As Nullable(Of Decimal)
#End Region

    Private Sub SetDefaultValuesForBindedProperties()
        _VALIDODAL = Date.Now
    End Sub

    Public Sub New()
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

    Protected Sub InitPrivateProperties()
        _IDCONTO = 0
        _IDCONDIZIONE = 0
        _IDTIPO = 0
        _VALORE = Nothing
        _DESCRIZIONE = Nothing
        _VALIDOAL = Nothing
        _VIRGOLADOPPIA = 0
        _REALE = 0

        ' Per i campi con un Default nel DB metto il Default
        SetDefaultValuesForBindedProperties() ' Set Defaults from DB Schema Infos	
    End Sub

    Public Sub Clear()
        InitPrivateProperties()

        _PreviousStatus = EntityStatus.Empty
        _Status = EntityStatus.Empty
    End Sub

#Region "   Public properties generated from columns of the table"

    <ColumnMappingAttribute("IDCONTO", "NUMBER", True, False, False, 0, 5, 0)> _
  <Bindable(True)> _
    Public Property IDCONTO As Decimal
        Get
            Return _IDCONTO
        End Get
        Set(ByVal Value As Decimal)
            If Not Value.Equals(_IDCONTO) Then
                OnPropertyChanging("IDCONTO")
                _IDCONTO = Value
                OnPropertyChanged("IDCONTO")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("IDCONDIZIONE", "NUMBER", True, False, False, 0, 5, 0)> _
  <Bindable(True)> _
    Public Property IDCONDIZIONE As Decimal
        Get
            Return _IDCONDIZIONE
        End Get
        Set(ByVal Value As Decimal)
            If Not Value.Equals(_IDCONDIZIONE) Then
                OnPropertyChanging("IDCONDIZIONE")
                _IDCONDIZIONE = Value
                OnPropertyChanged("IDCONDIZIONE")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("IDTIPO", "NUMBER", True, False, False, 0, 5, 0)> _
  <Bindable(True)> _
    Public Property IDTIPO As Decimal
        Get
            Return _IDTIPO
        End Get
        Set(ByVal Value As Decimal)
            If Not Value.Equals(_IDTIPO) Then
                OnPropertyChanging("IDTIPO")
                _IDTIPO = Value
                OnPropertyChanged("IDTIPO")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("VALORE", "VARCHAR2", False, False, False, 30, 0, 0)> _
  <Bindable(True)> _
    Public Property VALORE As String
        Get
            Return _VALORE
        End Get
        Set(ByVal Value As String)
            If (_VALORE Is Nothing And Value IsNot Nothing) _
                OrElse (_VALORE IsNot Nothing AndAlso Not _VALORE.Equals(Value)) Then
                OnPropertyChanging("VALORE")
                _VALORE = Value
                OnPropertyChanged("VALORE")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("DESCRIZIONE", "VARCHAR2", False, False, True, 50, 0, 0)> _
  <Bindable(True)> _
    Public Property DESCRIZIONE As String
        Get
            Return _DESCRIZIONE
        End Get
        Set(ByVal Value As String)
            If (_DESCRIZIONE Is Nothing And Value IsNot Nothing) _
                OrElse (_DESCRIZIONE IsNot Nothing AndAlso Not _DESCRIZIONE.Equals(Value)) Then
                OnPropertyChanging("DESCRIZIONE")
                _DESCRIZIONE = Value
                OnPropertyChanged("DESCRIZIONE")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("VALIDODAL", "DATE", True, False, False, 0, 0, 0)> _
  <Bindable(True)> _
    Public Property VALIDODAL As DateTime
        Get
            Return _VALIDODAL
        End Get
        Set(ByVal Value As DateTime)
            If Not Value.Equals(_VALIDODAL) Then
                OnPropertyChanging("VALIDODAL")
                _VALIDODAL = Value
                OnPropertyChanged("VALIDODAL")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("VALIDOAL", "DATE", True, False, False, 0, 0, 0)> _
  <Bindable(True)> _
    Public Property VALIDOAL As DateTime
        Get
            Return _VALIDOAL
        End Get
        Set(ByVal Value As DateTime)
            If Not Value.Equals(_VALIDOAL) Then
                OnPropertyChanging("VALIDOAL")
                _VALIDOAL = Value
                OnPropertyChanged("VALIDOAL")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("VIRGOLADOPPIA", "NUMBER", False, False, True, 0, 19, 2)> _
  <Bindable(True)> _
    Public Property VIRGOLADOPPIA As Nullable(Of Decimal)
        Get
            Return _VIRGOLADOPPIA
        End Get
        Set(ByVal Value As Nullable(Of Decimal))
            If (_VIRGOLADOPPIA Is Nothing And Value IsNot Nothing) _
                OrElse (_VIRGOLADOPPIA IsNot Nothing AndAlso Not _VIRGOLADOPPIA.Equals(Value)) Then
                OnPropertyChanging("VIRGOLADOPPIA")
                _VIRGOLADOPPIA = Value
                OnPropertyChanged("VIRGOLADOPPIA")
            End If
        End Set
    End Property

    <ColumnMappingAttribute("REALE", "FLOAT", False, False, True, 0, 15, 0)> _
  <Bindable(True)> _
    Public Property REALE As Nullable(Of Decimal)
        Get
            Return _REALE
        End Get
        Set(ByVal Value As Nullable(Of Decimal))
            If (_REALE Is Nothing And Value IsNot Nothing) _
                OrElse (_REALE IsNot Nothing AndAlso Not _REALE.Equals(Value)) Then
                OnPropertyChanging("REALE")
                _REALE = Value
                OnPropertyChanged("REALE")
            End If
        End Set
    End Property
#End Region

#Region "   IEntity implementation"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> _
    Protected _Status As EntityStatus
    Public Event EntityChanged(ByVal sender As Object, ByVal e As EntityActionEventArgs) Implements Pezzoli.Data.Miranda.IEntity.EntityChanged

    Public Sub SetStatus(ByVal newStatus As Pezzoli.Data.Miranda.EntityStatus) Implements Pezzoli.Data.Miranda.IEntity.SetStatus
        If newStatus = _Status Then Exit Sub

        _PreviousStatus = _Status
        _Status = newStatus
        'RaiseEvent EntityChanged(Me, New EntityActionEventArgs())
        Select Case _Status
            Case EntityStatus.Editing
                If _PreviousStatus = EntityStatus.Empty Then
                    RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyNew))
                Else
                    RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
                End If

            Case EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Create))

            Case EntityStatus.Loaded
                UpdateBackupProperties() ' I valori vecchi diventano uguali a quelli attuali				
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Load))

            Case EntityStatus.Deleted
                UpdateBackupProperties() ' I valori vecchi diventano uguali a quelli attuali
                InitPrivateProperties() ' Pulisco i valori ufficiali
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.Delete))
        End Select
    End Sub

    <Bindable(False)> _
    <Browsable(False)> _
    Public ReadOnly Property Status As Pezzoli.Data.Miranda.EntityStatus Implements Pezzoli.Data.Miranda.IEntity.Status
        Get
            Return _Status
        End Get
    End Property
#End Region

#Region "   INotifyPropertyChanged implementation"
    Public Event PropertyChanged(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangedEventArgs) Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

    Protected Sub OnPropertyChanged(ByVal field As String)
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(field))
        SetStatus(EntityStatus.Editing)
    End Sub
#End Region

#Region "   INotifyPropertyChanging implementation"
    Public Event PropertyChanging(ByVal sender As Object, ByVal e As System.ComponentModel.PropertyChangingEventArgs) Implements System.ComponentModel.INotifyPropertyChanging.PropertyChanging

    Protected Sub OnPropertyChanging(ByVal field As String)
        RaiseEvent PropertyChanging(Me, New PropertyChangingEventArgs(field))
    End Sub
#End Region
#Region "   IEditableObject implementation"
    'Private _Editing as Boolean
    'Private _New As Boolean
    'Private _Parent As ....
    Protected _PreviousStatus As EntityStatus

#Region "   Members for saving original values of table linked columns"
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_IDCONTO As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_IDCONDIZIONE As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_IDTIPO As Decimal
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_VALORE As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_DESCRIZIONE As String
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_VALIDODAL As DateTime
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_VALIDOAL As DateTime
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_VIRGOLADOPPIA As Nullable(Of Decimal)
    <DebuggerBrowsable(DebuggerBrowsableState.Never)> Protected _Orig_REALE As Nullable(Of Decimal)
#End Region

    '   Friend Sub SetParent(ByVal parent As ...)
    '      _Parent = parent
    '   End Sub

    Protected Sub UpdateBackupProperties()
        _Orig_IDCONTO = _IDCONTO
        _Orig_IDCONDIZIONE = _IDCONDIZIONE
        _Orig_IDTIPO = _IDTIPO
        _Orig_VALORE = _VALORE
        _Orig_DESCRIZIONE = _DESCRIZIONE
        _Orig_VALIDODAL = _VALIDODAL
        _Orig_VALIDOAL = _VALIDOAL
        _Orig_VIRGOLADOPPIA = _VIRGOLADOPPIA
        _Orig_REALE = _REALE
    End Sub

    Public Sub BeginEdit() Implements System.ComponentModel.IEditableObject.BeginEdit
        'If Not _Editing Then 
        If _Status = EntityStatus.Empty Or _Status = EntityStatus.Loaded Then
            UpdateBackupProperties()
            '_Editing = True
            _PreviousStatus = _Status
            _Status = EntityStatus.Editing

            If _PreviousStatus = EntityStatus.Empty Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyNew))
            End If
            If _PreviousStatus = EntityStatus.Loaded Then
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ModifyLoaded))
            End If
        End If
    End Sub

    Public Sub CancelEdit(ByVal propertyName As LinkedProperties)
        If HasChanges(propertyName) Then
            Select Case propertyName
                Case LinkedProperties.IDCONTO
                    _IDCONTO = _Orig_IDCONTO
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDCONTO"))
                Case LinkedProperties.IDCONDIZIONE
                    _IDCONDIZIONE = _Orig_IDCONDIZIONE
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDCONDIZIONE"))
                Case LinkedProperties.IDTIPO
                    _IDTIPO = _Orig_IDTIPO
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IDTIPO"))
                Case LinkedProperties.VALORE
                    _VALORE = _Orig_VALORE
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("VALORE"))
                Case LinkedProperties.DESCRIZIONE
                    _DESCRIZIONE = _Orig_DESCRIZIONE
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("DESCRIZIONE"))
                Case LinkedProperties.VALIDODAL
                    _VALIDODAL = _Orig_VALIDODAL
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("VALIDODAL"))
                Case LinkedProperties.VALIDOAL
                    _VALIDOAL = _Orig_VALIDOAL
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("VALIDOAL"))
                Case LinkedProperties.VIRGOLADOPPIA
                    _VIRGOLADOPPIA = _Orig_VIRGOLADOPPIA
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("VIRGOLADOPPIA"))
                Case LinkedProperties.REALE
                    _REALE = _Orig_REALE
                    RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("REALE"))
            End Select

            If Not HasChanges() Then _Status = _PreviousStatus
        End If
        '_Editing = False
    End Sub

    Public Sub CancelEdit() Implements System.ComponentModel.IEditableObject.CancelEdit
        'If _New Then
        If _Status = EntityStatus.Empty Then
            '_Parent.Remove(Me)
        Else
            CancelEdit(LinkedProperties.IDCONTO)
            CancelEdit(LinkedProperties.IDCONDIZIONE)
            CancelEdit(LinkedProperties.IDTIPO)
            CancelEdit(LinkedProperties.VALORE)
            CancelEdit(LinkedProperties.DESCRIZIONE)
            CancelEdit(LinkedProperties.VALIDODAL)
            CancelEdit(LinkedProperties.VALIDOAL)
            CancelEdit(LinkedProperties.VIRGOLADOPPIA)
            CancelEdit(LinkedProperties.REALE)

            If _PreviousStatus = EntityStatus.Empty Then
                _Status = EntityStatus.Empty
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditNew))
            Else
                _Status = EntityStatus.Loaded
                RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.UndoEditLoaded))
            End If
        End If
        '_Editing = False
    End Sub

    Public Sub EndEdit() Implements System.ComponentModel.IEditableObject.EndEdit
        '_Editing = False
        '_New = False
        _PreviousStatus = _Status
        _Status = EntityStatus.Loaded
        'RaiseEvent EntityChanged(Me, System.EventArgs.Empty)
        If _PreviousStatus = EntityStatus.Loaded Then
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditLoaded))
        Else
            RaiseEvent EntityChanged(Me, New EntityActionEventArgs(EntityAction.ConfirmEditNew))
        End If
    End Sub

    Public Function GetOriginalValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case LinkedProperties.IDCONTO
                Return _Orig_IDCONTO
            Case LinkedProperties.IDCONDIZIONE
                Return _Orig_IDCONDIZIONE
            Case LinkedProperties.IDTIPO
                Return _Orig_IDTIPO
            Case LinkedProperties.VALORE
                Return _Orig_VALORE
            Case LinkedProperties.DESCRIZIONE
                Return _Orig_DESCRIZIONE
            Case LinkedProperties.VALIDODAL
                Return _Orig_VALIDODAL
            Case LinkedProperties.VALIDOAL
                Return _Orig_VALIDOAL
            Case LinkedProperties.VIRGOLADOPPIA
                Return _Orig_VIRGOLADOPPIA
            Case LinkedProperties.REALE
                Return _Orig_REALE
            Case Else
                Return Nothing
        End Select
    End Function

    Public Function HasChanges(ByVal propertyName As LinkedProperties) As Boolean
        Select Case propertyName
            Case LinkedProperties.IDCONTO
                If Not _IDCONTO.Equals(_Orig_IDCONTO) Then Return True
            Case LinkedProperties.IDCONDIZIONE
                If Not _IDCONDIZIONE.Equals(_Orig_IDCONDIZIONE) Then Return True
            Case LinkedProperties.IDTIPO
                If Not _IDTIPO.Equals(_Orig_IDTIPO) Then Return True
            Case LinkedProperties.VALORE
                If (_VALORE Is Nothing And _Orig_VALORE IsNot Nothing) _
                    OrElse (_VALORE IsNot Nothing AndAlso Not _VALORE.Equals(_Orig_VALORE)) Then
                    Return True
                End If
            Case LinkedProperties.DESCRIZIONE
                If (_DESCRIZIONE Is Nothing And _Orig_DESCRIZIONE IsNot Nothing) _
                    OrElse (_DESCRIZIONE IsNot Nothing AndAlso Not _DESCRIZIONE.Equals(_Orig_DESCRIZIONE)) Then
                    Return True
                End If
            Case LinkedProperties.VALIDODAL
                If Not _VALIDODAL.Equals(_Orig_VALIDODAL) Then Return True
            Case LinkedProperties.VALIDOAL
                If Not _VALIDOAL.Equals(_Orig_VALIDOAL) Then Return True
            Case LinkedProperties.VIRGOLADOPPIA
                If (_VIRGOLADOPPIA Is Nothing And _Orig_VIRGOLADOPPIA IsNot Nothing) _
                    OrElse (_VIRGOLADOPPIA IsNot Nothing AndAlso Not _VIRGOLADOPPIA.Equals(_Orig_VIRGOLADOPPIA)) Then
                    Return True
                End If
            Case LinkedProperties.REALE
                If (_REALE Is Nothing And _Orig_REALE IsNot Nothing) _
                    OrElse (_REALE IsNot Nothing AndAlso Not _REALE.Equals(_Orig_REALE)) Then
                    Return True
                End If
        End Select
        Return False
    End Function

    Public Function HasChanges() As Boolean
        'If _Status = Pezzoli.Data.Miranda.EntityStatus.Editing Then
        If HasChanges(LinkedProperties.IDCONTO) _
            Or HasChanges(LinkedProperties.IDCONDIZIONE) _
            Or HasChanges(LinkedProperties.IDTIPO) _
            Or HasChanges(LinkedProperties.VALORE) _
            Or HasChanges(LinkedProperties.DESCRIZIONE) _
            Or HasChanges(LinkedProperties.VALIDODAL) _
            Or HasChanges(LinkedProperties.VALIDOAL) _
            Or HasChanges(LinkedProperties.VIRGOLADOPPIA) _
            Or HasChanges(LinkedProperties.REALE) _
        Then
            Return True
        Else
            Return False
        End If
    End Function
#End Region


#Region "   Utilities"
    Public Shared Function MaxLength(ByVal propertyName As LinkedProperties) As Integer
        Select Case propertyName
            Case LinkedProperties.VALORE
                Return 30
            Case LinkedProperties.DESCRIZIONE
                Return 50
            Case Else
                Return Integer.MaxValue
        End Select
    End Function

    Public Shared Function DefaultValue(ByVal propertyName As LinkedProperties) As Object
        Select Case propertyName
            Case LinkedProperties.VALIDODAL
                Return Date.Now
            Case Else
                Return Nothing
        End Select
    End Function
#End Region
End Class